/*
	ProWesS, PROGS Windowing System

	PWAddType		Add an application specific type

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 14 January 1995
*/

#include "ProWesS_h"
#include "PWTypeDef_h"
#include "PWJob_h"

Error PWAddType(PWTypeDef *newtype)
{
	PWJob *jobinfo;

	/* start by testing if the object passed can be a typedef */
	if (newtype->flag!=PW_TYPEDEF_FLAG) return ERR_IPAR;

	/* make sure there is a job info block (and get it) */
	PWJobCreate(&jobinfo);

	/* link type into application specific list */
	if (jobinfo->ltyp_list)
	{
		newtype->flag=(int)jobinfo->ltyp_list;
	}
	jobinfo->ltyp_list=newtype;

	return ERR_OK;
}
