/*
	ProWesS, PROGS Windowing System

	ProWesS test for applic type -- demo with PROforma contents

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 15 May 1995
*/

#include <sms.h>
#include <win.h>
#include <ProWesS.h>

#define FONT "English 157"
#define STRING FONT
#define SIZE short2pt(100)
#define XMAX short2pt(500)
#define YMAX SIZE*7/5

pt Xpix2pt, Ypix2pt;
#define p100 short2pt(100)

typedef struct {
	pt scale;			/* scale factor for canas */
	PWObject applic;
} Global;

Error redraw(PWObject object, CanvasInfo *rinfo)
{
	int i,j,siz;
	Gstate gid=rinfo->gstate;
	Global *g;

	PWQuery(object,PW_GLOBAL_AUXILIARY,&g);

	Xpix2pt=rinfo->Xpix2pt;
	Ypix2pt=rinfo->Ypix2pt;

	/* adjust bbox to fit canvas */
	PFPaperColourGray(gid,0);
	PFPageClear(gid);				/* clear background */
	PFColourGray(gid,pt_hundred);
	PFPageScale(gid,g->scale);

	/* adjust page origin to reflect position in applic */
	PFPageOriginSet(gid,rinfo->xorg,rinfo->yorg);

	/* draw the contents (just some text) */
	PFFontLoad(gid,FONT);
	PFFontScale(gid,SIZE);
	PFMoveTo(gid,short2pt(10),SIZE);
	PFStringShow(gid,STRING);
}

Error scaleTwo(PWObject object)
{
	Global *g;
	PWQuery(object,PW_GLOBAL_AUXILIARY,&g);
	g->scale=short2pt(2);
SMSBreakSoft();
	PWChange(g->applic,PW_APPLIC_REDRAW,NULL);
	return ERR_OK;
}

Error scaleHalf(PWObject object)
{
	Global *g;
	PWQuery(object,PW_GLOBAL_AUXILIARY,&g);
	g->scale=pt_half;
SMSBreakSoft();
	PWChange(g->applic,PW_APPLIC_REDRAW,NULL);
	return ERR_OK;
}

Error calcsize(PWObject object, pt *size)
{
	Global *g;
	PWQuery(object,PW_GLOBAL_AUXILIARY,&g);
	*size=fixdiv(*size,g->scale);
	return ERR_OK;
}

void init()
{
	PWObject outl, box;
	Global _g,*g=&_g;

	LinkPROforma();
	g->scale=pt_one;

	PWCreate(NULL, &outl, PW_TYPE_OUTLINE,
				PW_OUTLINE_SLEEP_TEXT, "PROforma applic test",
				PW_OUTLINE_QUIT,
				PW_OUTLINE_QUIT_KEYPRESS, 27,
				PW_GLOBAL_AUXILIARY, g,
				NULL);

	PWCreate(outl, &box, PW_TYPE_CONTAINER,
				PW_SCALE_FACTOR, 0,
				NULL);
	PWCreate(box, NULL, PW_TYPE_LOOSE_ITEM,
				PW_LOOSE_TEXT, "PFPageScale 2",
				PW_LOOSE_ACTION_HIT, scaleTwo,
				NULL);
	PWCreate(box, NULL, PW_TYPE_LOOSE_ITEM,
				PW_LOOSE_TEXT, "PFPageScale .5",
				PW_LOOSE_ACTION_HIT, scaleHalf,
				NULL);

	PWCreate(outl, &g->applic, PW_TYPE_APPLIC,
				PW_APPLIC_CANVAS_LIST,
					PW_CANVAS_SIZE_PIX, 100,40,
					PW_CANVAS_ACTION_REDRAW, &redraw,
					PW_CANVAS_POINTER, SPRITE_HAND,
					NULL,
				PW_APPLIC_SCROLLBAR_Y,
				PW_APPLIC_YSCROLL_LIST,
					PW_SCROLL_MINDIST, short2pt(20),
					PW_SCROLL_MAXDIST, -short2pt(20),
					PW_SCROLL_MAXIMUM, YMAX,
					PW_SCROLL_CALCSIZE, calcsize,
					NULL,
				PW_APPLIC_SCROLLBAR_X,
				PW_APPLIC_XSCROLL_LIST,
					PW_SCROLL_MINDIST, short2pt(20),
					PW_SCROLL_MAXDIST, -short2pt(20),
					PW_SCROLL_MAXIMUM, XMAX,
					PW_SCROLL_CALCSIZE, calcsize,
					NULL,
				NULL);

	PWActivate(outl);
}
